

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.53. request_cancel &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.3.54. ruby_eval" href="ruby_eval.html" />
    <link rel="prev" title="7.3.52. reindex" href="reindex.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/commands/request_cancel.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="ruby_eval.html" title="7.3.54. ruby_eval"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="reindex.html" title="7.3.52. reindex"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.53. </span><code class="docutils literal notranslate"><span class="pre">request_cancel</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="request-cancel">
<h1><span class="section-number">7.3.53. </span><code class="docutils literal notranslate"><span class="pre">request_cancel</span></code><a class="headerlink" href="#request-cancel" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.3.53.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.9.</span></p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">request_cancel</span></code> command cancels a running request.</p>
<p>There are some limitations:</p>
<blockquote>
<div><ul class="simple">
<li><p>Request ID must be managed by user. (You need to assign unique key
for each request.)</p></li>
<li><p>Cancel request may be ignored. (You can send <code class="docutils literal notranslate"><span class="pre">request_cancel</span></code>
command multiple times for the same request ID.)</p></li>
<li><p>Only multithreading type Groonga server is supported. (You can use
with <a class="reference internal" href="../executables/groonga.html"><span class="doc">groonga executable file</span></a> based server but can’t
use with <a class="reference internal" href="../executables/groonga-httpd.html"><span class="doc">groonga-httpd</span></a>.)</p></li>
</ul>
</div></blockquote>
<p>See <a class="reference internal" href="../command/request_id.html"><span class="doc">Request ID</span></a> about request ID.</p>
<p>If the request is canceled, a <a class="reference internal" href="../command/return_code.html"><span class="doc">Return code</span></a> of the canceled request as below.</p>
<blockquote>
<div><ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">-5</span></code> (<code class="docutils literal notranslate"><span class="pre">GRN_INTERRUPTED_FUNCTION_CALL</span></code>) (Groonga version 6.0.1 before)</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">-77</span></code> (<code class="docutils literal notranslate"><span class="pre">GRN_CANCEL</span></code>) (Groonga version 6.0.1 or later)</p></li>
</ul>
</div></blockquote>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.53.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p>This command takes only one required parameter:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>request_cancel id
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.53.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here is an example of <code class="docutils literal notranslate"><span class="pre">request_cancel</span></code> command:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>$ curl &#39;http://localhost:10041/d/select?table=LargeTable&amp;filter=true&amp;request_id=unique-id-1&#39; &amp;
# The above &quot;select&quot; takes a long time...
# Point: &quot;request_id=unique-id-1&quot;
$ curl &#39;http://localhost:10041/d/request_cancel?id=unique-id-1&#39;
[[...], {&quot;id&quot;: &quot;unique-id-1&quot;, &quot;canceled&quot;: true}]
# Point: &quot;id=unique-id-1&quot;
</pre></div>
</div>
<p>Assume that the first <code class="docutils literal notranslate"><span class="pre">select</span></code> command takes a long
time. <code class="docutils literal notranslate"><span class="pre">unique-id-1</span></code> request ID is assigned to the <code class="docutils literal notranslate"><span class="pre">select</span></code> command
by <code class="docutils literal notranslate"><span class="pre">request_id=unique-id-1</span></code> parameter.</p>
<p>The second <code class="docutils literal notranslate"><span class="pre">request_cancel</span></code> command passes <code class="docutils literal notranslate"><span class="pre">id=unique-id-1</span></code>
parameter. <code class="docutils literal notranslate"><span class="pre">unique-id-1</span></code> is the same request ID passed in <code class="docutils literal notranslate"><span class="pre">select</span></code>
command.</p>
<p>The <code class="docutils literal notranslate"><span class="pre">select</span></code> command may not be canceled immediately. And the cancel
request may be ignored.</p>
<p>You can send cancel request for the same request ID multiple times. If
the target request is canceled or finished, <code class="docutils literal notranslate"><span class="pre">&quot;canceled&quot;</span></code> value is
changed to <code class="docutils literal notranslate"><span class="pre">false</span></code> from <code class="docutils literal notranslate"><span class="pre">true</span></code> in return value:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>$ curl &#39;http://localhost:10041/d/request_cancel?id=unique-id-1&#39;
[[...], {&quot;id&quot;: &quot;unique-id-1&quot;, &quot;canceled&quot;: true}]
# &quot;select&quot; is still running... (&quot;canceled&quot; is &quot;true&quot;)
$ curl &#39;http://localhost:10041/d/request_cancel?id=unique-id-1&#39;
[[...], {&quot;id&quot;: &quot;unique-id-1&quot;, &quot;canceled&quot;: true}]
# &quot;select&quot; is still running... (&quot;canceled&quot; is &quot;true&quot;)
$ curl &#39;http://localhost:10041/d/request_cancel?id=unique-id-1&#39;
[[...], {&quot;id&quot;: &quot;unique-id-1&quot;, &quot;canceled&quot;: false}]
# &quot;select&quot; is canceled or finished. (&quot;canceled&quot; is &quot;false&quot;)
</pre></div>
</div>
<p>If the <code class="docutils literal notranslate"><span class="pre">select</span></code> command is canceled, response of the <code class="docutils literal notranslate"><span class="pre">select</span></code>
command has <code class="docutils literal notranslate"><span class="pre">-5</span></code> (<code class="docutils literal notranslate"><span class="pre">GRN_INTERRUPTED_FUNCTION_CALL</span></code>) as
<a class="reference internal" href="../command/return_code.html"><span class="doc">Return code</span></a>:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>$ curl &#39;http://localhost:10041/d/select?table=LargeTable&amp;filter=true&amp;request_id=unique-id-1&#39; &amp;
[[-5, ...], ...]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.53.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>This section describes parameters of <code class="docutils literal notranslate"><span class="pre">request_cancel</span></code>.</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.3.53.4.1. </span>Required parameters<a class="headerlink" href="#required-parameters" title="Permalink to this headline">¶</a></h3>
<p>There is required parameter, <code class="docutils literal notranslate"><span class="pre">id</span></code>.</p>
<div class="section" id="id">
<h4><span class="section-number">7.3.53.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">id</span></code><a class="headerlink" href="#id" title="Permalink to this headline">¶</a></h4>
<p>Specifies the ID for the target request.</p>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.3.53.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">request_cancel</span></code> command returns the result of the cancel request:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[
  HEADER,
  {
    &quot;id&quot;:       ID,
    &quot;canceled&quot;: CANCEL_REQUEST_IS_ACCEPTED_OR_NOT
  }
]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">HEADER</span></code></p>
<blockquote>
<div><p>See <a class="reference internal" href="../command/output_format.html"><span class="doc">Output format</span></a> about <code class="docutils literal notranslate"><span class="pre">HEADER</span></code>.</p>
</div></blockquote>
<p><code class="docutils literal notranslate"><span class="pre">ID</span></code></p>
<blockquote>
<div><p>The ID of the target request.</p>
</div></blockquote>
<p><code class="docutils literal notranslate"><span class="pre">CANCEL_REQUEST_IS_ACCEPTED_OR_NOT</span></code></p>
<blockquote>
<div><p>If the cancel request is accepted, this is <code class="docutils literal notranslate"><span class="pre">true</span></code>, otherwise this
is <code class="docutils literal notranslate"><span class="pre">false</span></code>.</p>
<p>Note that “cancel request is accepted” doesn’t means that “the
target request is canceled”. It just means “cancel request is
notified to the target request but the cancel request may be ignored
by the target request”.</p>
<p>If request assigned with the request ID doesn’t exist, this is
<code class="docutils literal notranslate"><span class="pre">false</span></code>.</p>
</div></blockquote>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.3.53.6. </span>See also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../command/request_id.html"><span class="doc">Request ID</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.53. <code class="docutils literal notranslate"><span class="pre">request_cancel</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.53.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.3.53.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.3.53.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.3.53.4. Parameters</a><ul>
<li><a class="reference internal" href="#required-parameters">7.3.53.4.1. Required parameters</a><ul>
<li><a class="reference internal" href="#id">7.3.53.4.1.1. <code class="docutils literal notranslate"><span class="pre">id</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.53.5. Return value</a></li>
<li><a class="reference internal" href="#see-also">7.3.53.6. See also</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="reindex.html"
                        title="previous chapter"><span class="section-number">7.3.52. </span><code class="docutils literal notranslate"><span class="pre">reindex</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="ruby_eval.html"
                        title="next chapter"><span class="section-number">7.3.54. </span><code class="docutils literal notranslate"><span class="pre">ruby_eval</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="ruby_eval.html" title="7.3.54. ruby_eval"
             >next</a> |</li>
        <li class="right" >
          <a href="reindex.html" title="7.3.52. reindex"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.53. </span><code class="docutils literal notranslate"><span class="pre">request_cancel</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>